# https://docs.soliditylang.org/en/latest/yul.html
OPCODES = {
    'stop': 1,
    'add': 2,
    'sub': 3,
    'mul': 4,
    'div': 5,
    'sdiv': 6,
    'mod': 7,
    'smod': 8,
    'exp': 9,
    'not': 10,
    'lt': 11,
    'gt': 12,
    'slt': 13,
    'sgt': 14,
    'eq': 15,
    'iszero': 16,
    'and': 17,
    'or': 18,
    'xor': 19,
    'byte': 20,
    'shl': 21,
    'shr': 22,
    'sar': 23,
    'addmod': 24,
    'mulmod': 25,
    'signextend': 26,
    'keccak256': 27,
    'keccak': 27,  
    'pc': 29,
    'pop': 30,
    'mload': 31,
    'mstore': 32,
    'mstore8': 33,
    'sload': 34,
    'sstore': 35,
    'msize': 36,
    'gas': 37,
    'address': 38,
    'balance': 39,
    'selfbalance': 40,
    'caller': 41,
    'callvalue': 42,
    'calldataload': 43,
    'calldatasize': 44,
    'calldatacopy': 45,
    'codesize': 46,
    'codecopy': 47,
    'extcodesize': 48,
    'extcodecopy': 49,
    'returndatasize': 50,
    'returndatacopy': 51,
    'extcodehash': 52,
    'create': 53,
    'create2': 54,
    'call': 55,
    'callcode': 56,
    'delegatecall': 57,
    'staticcall': 58,
    'return': 59,
    'revert': 60,
    'selfdestruct': 61,
    'invalid': 62,
    'log0': 63,
    'log1': 64,
    'log2': 65,
    'log3': 66,
    'log4': 67,
    'chainid': 68,
    'basefee': 69,
    'origin': 70,
    'gasprice': 71,
    'blockhash': 72,
    'coinbase': 73,
    'timestamp': 74,
    'number': 75,
    'difficulty': 76,
    'gaslimit': 77,
}

OLD_OPCODES = {
    'swap': 1,
    'swap1': 1,
    'swap2': 1,
    'swap3': 1,
    'swap4': 1,
    'swap5': 1,
    'swap6': 1,
    'swap7': 1,
    'swap8': 1,
    'swap9': 1,
    'swap10': 1,
    'swap11': 1,
    'swap12': 1,
    'swap13': 1,
    'swap14': 1,
    'swap15': 1,
    'swap16': 1,
    'dup': 2,
    'dup1': 2,
    'dup2': 2,
    'dup3': 2,
    'dup4': 2,
    'dup5': 2,
    'dup6': 2,
    'dup7': 2,
    'dup8': 2,
    'dup9': 2,
    'dup10': 2,
    'dup11': 2,
    'dup12': 2,
    'dup13': 2,
    'dup14': 2,
    'dup15': 2,
    'dup16': 2,
    'jumpdest': 3,
    'jump': 4,
    'jumpi': 5,
    'suicide': 6,
    'sha3': 7,  # Same as keccak256
    'push': 8,
    'push1': 8,
    'push2': 8,
    'push3': 8,
    'push4': 8,
    'push5': 8,
    'push6': 8,
    'push7': 8,
    'push8': 8,
    'push9': 8,
    'push10': 8,
    'push11': 8,
    'push12': 8,
    'push13': 8,
    'push14': 8,
    'push15': 8,
    'push16': 8,
    'push17': 8,
    'push18': 8,
    'push19': 8,
    'push20': 8,
    'push21': 8,
    'push22': 8,
    'push23': 8,
    'push24': 8,
    'push25': 8,
    'push26': 8,
    'push27': 8,
    'push28': 8,
    'push29': 8,
    'push30': 8,
    'push31': 8,
    'push32': 8,
}

HIGH_LEVEL_CONSTRUCTS = {
    'for': 1,
    'if': 2,
    'switch': 3,
    'leave': 4,
}

DECLARATIONS = {
    'let': 1,  # Translated to PUSHi
    'function': 2,
}

SPECIAL = {
    'datasize': 1,
    'dataoffset': 2,
    'datacopy': 3,
    'setimmutable': 4,
    'loadimmutable': 5,
    'linkersymbol': 6,
    'memoryguard': 7,
    'verbatim': 8,
}
